# Changelog

### controller-v1.12.1

Images:

* registry.k8s.io/ingress-nginx/controller:v1.12.1@sha256:d2fbc4ec70d8aa2050dd91a91506e998765e86c96f32cffb56c503c9c34eed5b
* registry.k8s.io/ingress-nginx/controller-chroot:v1.12.1@sha256:90155c86548e0bb95b3abf1971cd687d8f5d43f340cfca0ad3484e2b8351096e

### All changes:

* Images: Trigger controller build. (#13071)
* Controller: Several security fixes. (#13069)
* Chart: Bump Kube Webhook CertGen. (#13066)
* Tests & Docs: Bump images. (#13064)
* Images: Trigger other builds (2/2). (#13061)
* Images: Trigger other builds (1/2). (#13059)
* Tests: Bump Test Runner to v1.3.1. (#13048)
* Images: Trigger Test Runner build. (#13045)
* Images: Bump `NGINX_BASE` to v1.2.1. (#13044)
* Images: Trigger NGINX build. (#13039)
* Go: Update dependencies. (#13036)
* CI: Update KIND to v1.32.3. (#13029)
* CI: Update Kubernetes to v1.32.3. (#13025)
* Images: Rework. (3/3) (#13016)
* Images: Rework. (2/3) (#13011)
* Images: Rework. (1/3) (#13014)
* Custom Error Pages: Accept first of many MIME types. (#13006)
* Docs: Use `enable-global-auth` annotation instead of non-existing ConfigMap option. (#12978)
* Go: Update dependencies. (#12963)
* Docs: Update link to `values.yaml`. (#12960)
* fix DNS issues with unresolvable backends with ExternalName (#12951)
* Go: Bump to v1.24.1. (#12942)
* CI: Update KIND images. (#12931)
* Test: Remove gRPC Fortune Teller. (#12929)
* NGINX: Update ModSecurity. (#12915)
* Development: Update KIND images. (#12909)
* Config: Remove notes about future defaults. (#12898)
* Images: Update `kubectl` to v1.32.2. (#12856)
* Development: Update Kubernetes to v1.32.0. (#12853)
* CI: Update `kubectl` to v1.32.2. (#12851)
* Images: Migrate to AR. (2/2) (#12849)
* Images: Migrate to AR. (1/2) (#12846)
* Docs: Migrate to AR. (#12809)
* Docs: Enable code copy button. (#12805)
* Go: Bump to v1.23.6. (#12801)
* CI: Update Artifact Hub to v1.20.0. (#12793)
* Images: Update `kubectl` to v1.31.5. (#12791)
* CI: Update `kubectl` to v1.31.5. (#12789)
* Development: Bump Kubernetes to v1.31.4. (#12784)
* Go: Replace `golang.org/x/exp/slices` with `slices`. (#12781)
* Docs: Fix character format. (#12773)
* Docs: Improve bare-metal setup. (#12744)
* Build: Always use local `tmp` dir on macOS. (#12741)
* Development: Bump Kubernetes to v1.31.4. (#12739)
* Images: Bump `gcb-docker-gcloud` to v20250116-2a05ea7e3d. (#12738)
* Go: Bump to v1.23.5. (#12736)
* Docs: Clarify rate limits are per ingress controller replica. (#12715)
* Go: Stop using workspace. (#12712)
* Chart: Bump Kube Webhook CertGen. (#12696)
* Tests & Docs: Bump images. (#12694)
* Images: Trigger other builds (2/2). (#12690)
* Images: Trigger other builds (1/2). (#12688)
* Tests: Bump Test Runner to v20250112-01b7af21. (#12684)
* Images: Trigger Test Runner build. (#12681)
* Images: Bump `NGINX_BASE` to v1.2.0. (#12677)
* Images: Trigger NGINX build. (#12674)
* NGINX: Align quotes. (#12673)
* Annotations: Deny newlines. (#12667)
* Annotations: Reload on custom header changes. (#12652)
* NGINX: Bump ModSecurity. (#12651)
* NGINX: Bump OpenTelemetry. (#12631)

### Dependency updates:

* Bump github.com/opencontainers/runc from 1.2.5 to 1.2.6 in the go group across 1 directory (#13033)
* Bump github.com/onsi/ginkgo/v2 from 2.23.0 to 2.23.3 (#13027)
* Bump the actions group with 5 updates (#13023)
* Bump dorny/test-reporter from 1.9.1 to 2.0.0 (#12989)
* Bump github.com/prometheus/common from 0.62.0 to 0.63.0 (#12987)
* Bump the go group across 3 directories with 9 updates (#12985)
* Bump the actions group with 3 updates (#12984)
* Bump github/codeql-action from 3.28.10 to 3.28.11 in the actions group (#12968)
* Bump github.com/onsi/ginkgo/v2 from 2.22.2 to 2.23.0 (#12958)
* Bump golang.org/x/crypto from 0.35.0 to 0.36.0 (#12955)
* Bump the go group across 2 directories with 1 update (#12938)
* Bump google.golang.org/grpc from 1.70.0 to 1.71.0 (#12937)
* Bump golang.org/x/crypto from 0.34.0 to 0.35.0 (#12923)
* Bump the actions group with 3 updates (#12921)
* Bump github.com/prometheus/client_golang from 1.20.5 to 1.21.0 (#12900)
* Bump golang.org/x/crypto from 0.33.0 to 0.34.0 (#12893)
* Bump github.com/prometheus/client_golang from 1.20.5 to 1.21.0 in /images/custom-error-pages/rootfs (#12892)
* Bump the actions group with 4 updates (#12889)
* Bump github.com/spf13/cobra from 1.8.1 to 1.9.1 (#12867)
* Bump the go group across 3 directories with 11 updates (#12865)
* Bump the actions group with 2 updates (#12863)
* Bump github.com/spf13/cobra from 1.8.1 to 1.9.1 in /images/kube-webhook-certgen/rootfs (#12861)
* Bump the actions group with 4 updates (#12814)
* Bump golang.org/x/crypto from 0.32.0 to 0.33.0 (#12812)
* Bump the actions group with 2 updates (#12777)
* Bump the go group across 2 directories with 1 update (#12775)
* Bump google.golang.org/grpc from 1.69.4 to 1.70.0 (#12760)
* Bump sigs.k8s.io/controller-runtime from 0.20.0 to 0.20.1 in the go group across 1 directory (#12758)
* Bump the actions group with 5 updates (#12756)
* Bump sigs.k8s.io/controller-runtime from 0.19.4 to 0.20.0 (#12732)
* Bump github.com/prometheus/common from 0.61.0 to 0.62.0 (#12728)
* Bump the go group across 3 directories with 9 updates (#12726)
* Bump golangci/golangci-lint-action from 6.1.1 to 6.2.0 in the actions group (#12725)
* Bump google.golang.org/grpc from 1.69.2 to 1.69.4 in the go group across 1 directory (#12699)
* Bump the actions group with 3 updates (#12664)
* Bump the go group across 1 directory with 3 updates (#12662)
* Bump golang.org/x/crypto from 0.31.0 to 0.32.0 (#12661)
* Bump github.com/onsi/ginkgo/v2 from 2.22.1 to 2.22.2 (#12628)

**Full Changelog**: https://github.com/kubernetes/ingress-nginx/compare/controller-v1.12.0...controller-v1.12.1
